---
name: Build and Tests

on:
  push:
    tags-ignore:
      - '**'
    branches:
      - main
  pull_request:
    branches:
      - main

jobs:
  build:
    name: Build and Tests
    runs-on: ubuntu-latest
    steps:
    - name: Set up Go
      uses: actions/setup-go@v2
      with:
        go-version: 1.17.x

    - name: Check out code into the Go module directory
      uses: actions/checkout@v2

    - name: Verify Go Modules Setup
      run: |
        go mod verify

    - name: Install Tools
      run: |
        pushd "$(mktemp -d)"
        go get github.com/gordonklaus/ineffassign
        go get golang.org/x/lint/golint
        go get github.com/client9/misspell/cmd/misspell
        go get honnef.co/go/tools/cmd/staticcheck
        go get github.com/onsi/ginkgo/ginkgo github.com/onsi/gomega/...
        popd

    - name: Build Go Code
      run: |
        go build ./...

    - name: Sanity Check (go vet)
      run: |
        go vet ./...

    - name: Sanity Check (ineffassign)
      run: |
        go get github.com/gordonklaus/ineffassign
        ineffassign ./...

    - name: Sanity Check (golint)
      run: |
        golint ./...

    - name: Sanity Check (misspell)
      run: |
        find . -type f | xargs misspell -source=text -error

    - name: Sanity Check (staticcheck)
      run: |
        staticcheck ./...

    - name: Run Go Unit Tests
      run: |
        ginkgo -randomizeAllSpecs -randomizeSuites -failOnPending -nodes=1 -compilers=1 -race -trace -cover

    - name: Upload Code Coverage Profile
      uses: codecov/codecov-action@v1
      with:
        files: ./*.coverprofile
        flags: unittests
        fail_ci_if_error: true
        verbose: false
